﻿function RenderCustomFieldInput(fieldId, value, type, callback, parentFieldId) {
	if ($("#CustomFieldValue" + fieldId).length) {
		if (callback) callback();
		return; //already exists
	}

	$.ajax(HDApp.Url + "Ticket/CustomFieldInput", {
		type: "POST",
		data: { fieldId: fieldId, value: value, type: type, parentFieldId: parentFieldId },
		success: function (html) {
			$('#spanFldEdit' + fieldId).prepend(html);
			//reinit location
			InitLocationFields(); //defined in utils.js
			$('.multiselectCF').multiselect({minWidth: "100%", header: false});
			if (callback) callback();
		}
	}); 
}

function SaveCustomField(fieldId) {
	var $input = $('#CustomFieldValue' + fieldId);
	var fieldValue = $input.is(':checkbox')
		? ($input.prop('checked') ? "1" : "0") //checkbox? set to "0" or "1"
		: $input.val();

	if (!fieldValue && !$('#spanFldValue' + fieldId + ' .cfText').text()) return; //empty value re-saving? return to prevent extra backend call, adding empty comment etc.

	$.post(HDApp.Url + "Ticket/SaveCustomFieldValue", { ticketId: HDApp.TicketId, fieldId: fieldId, value: fieldValue });

	if ($input.is("select")) { // is it a combobox?
		if ($input.attr("multiple"))
			$('#spanFldValue' + fieldId).text($input.val());
		else
			$('#spanFldValue' + fieldId).text($input.find('option:selected').text());
		$('#spanFldValue' + fieldId).data("selectedoptionid", $input.val());
	}
	/* checkbox commented out - b/c checkboxes are saved differently
	else if ($input.is(":checkbox"))
		$('#spanFldValue' + fieldId).html("<input type='checkbox' disabled='disabled' " + (fieldValue == true ? "checked='checked'" : "") + " />");
	*/
	else if ($input.hasClass("locationCF"))
		$('#spanFldValue' + fieldId).html("<a target='_blank' href='http://maps.google.com?q=" + encodeURIComponent(fieldValue) + "'>" + fieldValue + "</a>");
	else if ($input[0].type == "date") { //date CF? show text in current culture format, not as "yyyy-MM-dd" after saving
		$('#spanFldValue' + fieldId + ' .cfText').text(Utils.formatDateLocale(fieldValue, withTime = false));
	}
	else if ($input[0].type.startsWith("datetime")) { //datetime CF? same
		$('#spanFldValue' + fieldId + ' .cfText').text(Utils.formatDateLocale(fieldValue, withTime = true));
	}
	else {
		HtmlSanitizer.AllowedAttributes["checked"] = true;
		$('#spanFldValue' + fieldId + ' .cfText').html(HtmlSanitizer.SanitizeHtml(
			fieldValue
				.replace(/\n/g, "<br>")
				.replace(/- \[ \]/g, "<input type=checkbox>")
				.replace(/- \[x\]/g, "<input type=checkbox checked>"), "input"));
		delete HtmlSanitizer.AllowedAttributes["checked"];
	}
	$('#spanFldEdit' + fieldId).hide();
	$('#spanFldValue' + fieldId).show();

	$(".cfText").each(function () { this.innerHTML = convertToLink(this.innerHTML); });
}

function InitDependentOptions() {
	$("select[data-parentId] option[value!='']").hide().prop("disabled", true); //hide & disable all
	$("select[data-parentId]").each(function () {
		var parentId = $(this).data('parentid'); //find parent fieldId
		var parentOptionId = $('#spanFldValue' + parentId).data("selectedoptionid"); //find the selected option for the parent field
		if (parentOptionId)
			$(this).find("option[data-parentOptionId=" + parentOptionId + "]").show().prop("disabled", false); //show and enable
	});
}

$(function () {
	$(".cfText").each(function () { this.innerHTML = convertToLink(this.innerHTML); });
});