﻿// validate datalist input
(function () {
	// search for all datalists and add custom validation
	var datalists = document.querySelectorAll("datalist");
	if (!datalists.length)
		return;

	// support for multiple datalists on a page
	for (var i = 0; i < datalists.length; i++) {
		var dl = datalists[i];
		//find the input for that datalist
		var dlId = dl.attributes['id'].value;
		var input = document.querySelector('input[list="' + dlId + '"]');

		// the hidden input where we store the actual value
		var hiddenInput = document.getElementById(input.attributes["id"].value + "-hidden");

		// now get the form
		var form = input.form;

		// add validation listener
		form.addEventListener("submit", function (e) {
			var datalistValues = [...dl.options].map(o => o.value);
			if (dl.classList.contains("allowNew") || datalistValues.includes(input.value)) { // valid (or non-existing value allowed)
				input.classList.remove("error");
				input.setCustomValidity("");

				// the value is valid. Now let's check if there is an actual value we can use
				// get selected option
				var option = dl.querySelector("option[value='" + input.value + "']");
				if (option.hasAttribute("data-value")) // use this value instead
					hiddenInput.value = option.attributes["data-value"].value;
				else
					hiddenInput.value = option.value;

				return true;
			}
			else if(input.offsetParent!=null) { //not "hidden" via CSS
				input.classList.add("error");
				input.setCustomValidity("Select one of the values from the suggestion list");
				e.preventDefault();
				return false;
			}
		});
	}
})();