﻿
//short jquery plugin, only 10 lines, uses most functionality from the old object below
(function ($) {
	$.fn.wswgEditor = function (options, params) {
		if (options === Object(options) || !options) { //i.e. "are we called using options?" this ugly code is needed to create "plugin with methods", see https://stackoverflow.com/a/6871820/56621

			var settings = $.extend({ // This is the easiest way to have default options.
				wysiwyg: true,
				editbar: true,
				noSanitation: false,
				checkboxBtn: false
			}, options);

			HtmlSanitizer.AllowedAttributes["dir"] = true;
			HtmlSanitizer.AllowedCssStyles["direction"] = true; 

			return this.each(function () { //iterate through selector
				if (!$(this).data("wswgeditor")) { //if "data" is STILL UNSET
					var editorObj = new editorClass(this.id, settings); //create and init editor object with all methods
					editorObj.initEditor();
					$(this).data("wswgeditor", editorObj); //save it into "data"
					if (!window.wswgEditor) //backward compatibility for old external code - simply set "window.wswgEditor" to the first editor object in the selector
						window.wswgEditor = editorObj;
				}
			});
		}

		if (this.length === 1) { //if a "method" is called, like this: $(blah).wswgEditor("execCmd", "italic")
			var editorObj = $(this).data("wswgeditor");
			switch (options) {
				case 'execCmd':
					editorObj.doCmd(arguments[1], arguments[2]); return;
				case 'doLink':
					editorObj.doLink(); return;
				case 'doImage':
					editorObj.doImage(); return;
				case 'doCode':
					editorObj.doCode(); return;
				case 'switchEditor':
					editorObj.SwitchEditor(); return;
				case 'doCheck':
					editorObj.doCheck(); return;
				case 'insertText':
					editorObj.InsertText(arguments[1]); return;
			}
		}
	}
}(jQuery));

function editorClass(textarea_id, settings) {

	this.getEditorDoc = function () { return ifm; }
	this.IsEditorVisible = function () { return editorVisible; }

	var ifm;
	var body_id, textboxelement;
	var content;
	var ua = navigator.userAgent.toLowerCase();
	var isFirefox = ua.indexOf('firefox') > -1;
	var isSafari = ua.indexOf('safari') != -1 && ua.indexOf('chrome') == -1;
	var editorVisible = false;
	var enableWysiwyg = settings.wysiwyg;
	var docheckCalledRecentlyFromBlur = false;
	var _range;

	var curScriptUrl = document.currentScript || $('script[src*="/editor.js"]').attr('src');

	var self = this; //i fucking hate js for this... lets save reference to "this" because "this" will point to different stuff depenpding on scope

	this.initEditor = function () {
		body_id = textarea_id;
		textboxelement = document.getElementById(body_id);
		textboxelement.className += " editorBBCODE";
		if (enableWysiwyg) {
			if (!document.getElementById("rte" + textarea_id)) { //to prevent recreation
				AddEditBar(); //create button bar
				ifm = document.createElement("div");
				ifm.setAttribute("id", "rte" + textarea_id);
				ifm.style.width = textboxelement.style.width;
				ifm.style.height = textboxelement.style.height;
				textboxelement.insertAdjacentElement("beforebegin", ifm);
				textboxelement.style.display = 'none';
			}
			if (ifm) {
				InitIframe();
			} else
				setTimeout('InitIframe()', 100);
		}
	}

	function AddEditBar() {
		var code = '<div class="richeditor">';

		if (settings.editbar) {
			code +='\
				<div class="editbar">\
					<button tabindex="-1" class="boldbtn fa fa-bold" title="bold" aria-label="bold" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'bold\');" type="button"></button>\
					<button tabindex="-1" class="italicbtn fa fa-italic" title="italic" aria-label="italic" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'italic\');" type="button"></button>\
					<button tabindex="-1" class="underlinebtn fa fa-underline" title="underline" aria-label="underline" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'underline\');" type="button"></button>\
					<div class="dropdown" style="display:inline-block">\
					<button tabindex="-1" class="dropdown-toggle fa fa-align-center" data-toggle="dropdown" title="align" aria-label="align" type="button"> <i class="fa fa-angle-down"></i></button>\
						<ul class="dropdown-menu outerroundedbox">\
							<button tabindex="-1" title="left" aria-label="left" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'justifyLeft\');" type="button"><i class="fa fa-align-left"></i></button>\
							<button tabindex="-1" title="center" aria-label="center" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'justifyCenter\');" type="button"><i class="fa fa-align-center"></i></button>\
							<button tabindex="-1" title="right" aria-label="right" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'justifyRight\');" type="button"><i class="fa fa-align-right"></i></button>\
						</ul>\
					</div>\
					\
					<div class="dropdown" style="display:inline-block">\
					<button tabindex="-1" class="dropdown-toggle fa fa-text-height" data-toggle="dropdown" title="heading" aria-label="headings" type="button"> <i class="fa fa-angle-down"></i></button>\
						<ul class="dropdown-menu outerroundedbox">\
							<button tabindex="-1" title="H1" aria-label="H1" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'formatBlock\', \'<h1>\');" type="button">H1</button>\
							<button tabindex="-1" title="H2" aria-label="H2" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'formatBlock\', \'<h2>\');" type="button">H2</button>\
							<button tabindex="-1" title="H3" aria-label="H3" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'formatBlock\', \'<h3>\');" type="button">H3</button>\
							<button tabindex="-1" title="None" aria-label="None" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'formatBlock\', \'<div>\');" type="button"><i class="fa fa-paragraph"></i></button>\
						</ul>\
					</div>\
					\
					<div class="dropdown" style="display:inline-block">\
					<button tabindex="-1" class="dropdown-toggle fa fa-list-ul" data-toggle="dropdown" title="lists" aria-label="lists" type="button"> <i class="fa fa-angle-down"></i></button>\
						<ul class="dropdown-menu outerroundedbox">\
							<button tabindex="-1" class="listbtn fa fa-list-ul" title="unordered list" aria-label="unordered list" type="button" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'InsertUnorderedList\');"></button>\
							<button tabindex="-1" class="listbtn fa fa-list-ol" title="ordered list" aria-label="ordered list" type="button" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'InsertOrderedList\');"></button>\
							<button tabindex="-1" class="listbtn fa fa-indent" title="indent" type="button" aria-label="indent" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'indent\');"></button>\
							<button tabindex="-1" class="listbtn fa fa-outdent" title="outdent" type="button" aria-label="outdent" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'outdent\');"></button>\
						</ul>\
					</div>\
					\
					<button tabindex="-1" class="hyperlinkbtn fa fa-link" title="hyperlink" aria-label="hyperlink" onclick="$(\'#'+ body_id + '\').wswgEditor(\'doLink\')" type="button"></button>\
					<button tabindex="-1" class="imagebtn fa fa-picture-o" title="image" aria-label="image" onclick="$(\'#'+ body_id + '\').wswgEditor(\'doImage\')" type="button"></button>\
					' + (settings.checkboxBtn ? '<button tabindex="-1" class="chackboxbtn fa fa-check-square" title="checkbox" aria-label="checkbox" onclick="$(\'#' + body_id + '\').wswgEditor(\'insertText\', \'<input type=checkbox>\')" type="button"></button>' : '') + '\
					<div class="dropdown" style="display:inline-block">\
					<button tabindex="-1" class="dropdown-toggle fa fa-smile-o" data-toggle="dropdown" aria-label="Emojis" title="Emojis. You can use Win+period or Ctrl+Cmd+space (on Mac) for even more emojis" type="button"></button>\
						<ul class="dropdown-menu outerroundedbox">\
							<button tabindex="-1" onclick="$(\'#'+ body_id + '\').wswgEditor(\'insertText\', \'😃\');" type="button">😃</button>\
							<button tabindex="-1" onclick="$(\'#'+ body_id + '\').wswgEditor(\'insertText\', \'😂\');" type="button">😂</button>\
							<button tabindex="-1" onclick="$(\'#'+ body_id + '\').wswgEditor(\'insertText\', \'👍\');" type="button">👍</button>\
							<button tabindex="-1" onclick="$(\'#'+ body_id + '\').wswgEditor(\'insertText\', \'👎\');" type="button">👎</button>\
							<button tabindex="-1" onclick="$(\'#'+ body_id + '\').wswgEditor(\'insertText\', \'🤞\');" type="button">🤞</button><br>\
							<button tabindex="-1" onclick="$(\'#'+ body_id + '\').wswgEditor(\'insertText\', \'❤️\');" type="button">❤️</button>\
							<button tabindex="-1" onclick="$(\'#'+ body_id + '\').wswgEditor(\'insertText\', \'🔥\');" type="button">🔥</button>\
							<button tabindex="-1" onclick="$(\'#'+ body_id + '\').wswgEditor(\'insertText\', \'🙏\');" type="button">🙏</button>\
							<button tabindex="-1" onclick="$(\'#'+ body_id + '\').wswgEditor(\'insertText\', \'🙁\');" type="button">🙁</button>\
							<button tabindex="-1" onclick="$(\'#'+ body_id + '\').wswgEditor(\'insertText\', \'🎉\');" type="button">🎉</button>\
						</ul>\
					</div>\
					\
					<button tabindex="-1" class="colorbtn fa fa-eyedropper" title="color" aria-label="color" type="button"></button>\
					<button tabindex="-1" class="srccode" title="fixed-width font (for source code)" aria-label="fixed-width font (for source code)" onclick="$(\'#'+ body_id + '\').wswgEditor(\'doCode\')" style="line-height:10px;" type="button"><span style="position:relative;top:-1px">{}</span></button>\
					&nbsp;&nbsp;\
					<button tabindex="-1" class="fa fa-ban" title="remove formatting for selection" aria-label="remove formatting for selection" onclick="$(\'#'+ body_id + '\').wswgEditor(\'execCmd\', \'removeFormat\')" type="button"></button>\
					<button tabindex="-1" class="htmlbtn fa fa-code" title="switch to source" aria-label="switch to source" type="button" onclick="$(\'#'+ body_id + '\').wswgEditor(\'switchEditor\')"></button>\
				</div>';
			code += '<div class="container"></div></div>'
		}
		else
			code += '<div class="container" style="border-top: 1px solid #ccc"></div></div>';

		var $wrap = $(code);
		var $textarea = $('#' + body_id);
		$textarea.parent().append($wrap);
		$textarea.replaceWith($wrap);
		$wrap.find(".container").append($textarea);

		InitColorPicker($wrap.find(".colorbtn"), function (color) { doColor(color); });
	}

	function InitIframe() {
		ifm.contentEditable = true;
		ifm.onblur = handleBlur;

		ifm.onkeydown = function handleKeydown(event) {
			if (isFirefox || isSafari) { //only for firefox (stupid bookmarks bar workaround)
				if (event.ctrlKey || event.metaKey) {
					switch (event.which) {
						case 66: //b
							event.preventDefault();
							self.doCmd('bold');
							return;
						case 73: //i
							event.preventDefault();
							self.doCmd('italic');
							return;
						case 85: //u
							event.preventDefault();
							self.doCmd('underline');
							return;
					}
				}
			}
			if (event.ctrlKey && event.which == 75) //ctrl+k
			{
				event.preventDefault();
				self.doLink();
				return;
			}
		};

		//ifm.contentEditable = true;
		ifm.addEventListener('paste', handlePaste);
		self.ShowEditor();

		//reflect checkbox change in HTML source
		$(ifm).on("click", "input[type=checkbox]", function () {
			if (this.checked)
				this.setAttribute("checked", "checked");
			else
				this.removeAttribute("checked");
			self.doCheck(); //update the html source too, b/c "onblur" might not not be called (checkbox click already triggered blur)
		});
	}

	function handleBlur(e) {
		//save range to restore it later
		var sel = window.getSelection && window.getSelection();
		//onblur has an issue in safari hence all the extra techs
		if (sel && sel.rangeCount > 0) {
			_range = sel.getRangeAt(0);
		}

		docheckCalledRecentlyFromBlur = true;
		self.doCheck();
		setTimeout(function () { docheckCalledRecentlyFromBlur = false; }, 500);
	}

	function handlePaste(e) {
		var clipboardData = e.clipboardData || window.clipboardData;
		if (!clipboardData || !clipboardData.items) return;

		_range = window.getSelection().getRangeAt(0); //save range to restore it later, so inserting image and html happens at cursor

		for (var i = 0; i < clipboardData.items.length; i++) {
			if (clipboardData.items[i].kind == "string") { // if we have text before image just take text. To prevent Excel, Outlook etc. pasting images instead of text\html

				var pastedHtml = e.clipboardData.getData('text/html');
				if (pastedHtml) { //is it html? sanitize, paste and then exit, so plain text part is not processed
					e.preventDefault(); //stop the default handler to prevent double paste

					let sanitizedHtml = HtmlSanitizer.SanitizeHtml(pastedHtml).trim();
					if (/^<img[^>]+>$/.test(sanitizedHtml) //if ALL this string has - is an img tag
						&& Array.from(clipboardData.items).filter(itm => itm.kind == "file").length) //and there's more "file" items in clipboard
						continue; //then skip to the file-item. When copying images latest browsers just put img-tag in clipboard along with binary image

					self.InsertText(sanitizedHtml); //inserts sanitized HTML at cursor

					$(ifm).find("img[src^='file:']").remove(); //remove images pointing to local files (when pasted from latest Word/Outlook)

					setTimeout(function () { $(ifm).find("img").resizable(); }, 300); //makes images resizable after pasting html
					return;
				}
			}

			if (clipboardData.items[i].kind == "file" && clipboardData.items[i].type.indexOf("image") > -1) {
				// it's an image, stop the default handler to prevent double paste in some browsers
				e.preventDefault();
				var imageFile = clipboardData.items[i].getAsFile();
				var fileReader = new FileReader();
				fileReader.onloadend = function () {
					AddImageByUrl(fileReader.result);
				}
				fileReader.readAsDataURL(imageFile);
				break;
			}
		}
		autoResize();//to force iframe resize after paste so widows scrolls down for big images
		return false;
	}

	function RemovePlaceholder() {
		var pElement = document.getElementById("placeholderspan");
		if (pElement) pElement.parentNode.removeChild(pElement);
		ifm.removeEventListener('focus', RemovePlaceholder);
	}

	this.ShowEditor = function () {
		if (!enableWysiwyg) return;
		editorVisible = true;
		ifm.style.display = '';
		textboxelement.style.display = 'none';

		content = document.getElementById(body_id).value;
		var placeholderText = document.getElementById(body_id).placeholder;
		if(content || !placeholderText)
		{
			content = settings.noSanitation ? content : HtmlSanitizer.SanitizeHtml(content, "input[type=checkbox]");
			ifm.innerHTML = content;
		}
		else { //write placeholder (if no content and placeholder is not empty)
			var phColor = window.getComputedStyle(textboxelement, '::placeholder').getPropertyValue("color");
			ifm.innerHTML = '<span style="color:' + phColor + '" id="placeholderspan">' + placeholderText + '</span>';
			ifm.addEventListener('focus', RemovePlaceholder); //remove placeholder on focus
		}
	}

	this.SwitchEditor = function () {
		if (editorVisible) {
			if (!docheckCalledRecentlyFromBlur)
				this.doCheck();
			ifm.style.display = 'none';
			textboxelement.style.display = '';
			editorVisible = false;
			textboxelement.focus();
		}
		else {
			if (enableWysiwyg && ifm) {
				this.ShowEditor();
				$(ifm).find("img").resizable(); //makes all images resizable
				ifm.focus();
			}
		}
	}

	this.doCheck = function () {
		if (!enableWysiwyg) return;
		RemovePlaceholder();
		if (editorVisible) {
			content = ifm.innerHTML;

			//check if the content is actually empty even tho it has some tags like <span><font><br></span>
			if ((!ifm.innerText || ifm.innerText.trim() == '') && content.indexOf("<img") == -1 && (!settings.noSanitation || content.indexOf("<iframe") == -1)) //no text and no images, also allow iframes if noSanitation
				content = "";

			content = settings.noSanitation ? content : HtmlSanitizer.SanitizeHtml(content, "input[type=checkbox]");

			content = content.replace(/(\w)<div/gi, "$1\n<div"); //add line break "blah<div>blah</div>" becasue this breaks FT search (and thats how chrome handles enter key first time)

			document.getElementById(body_id).value = content;
		}
	}

	this.Clear = function () {
		ifm.innerHTML = "";
		document.getElementById(body_id).value = "";
	}

	this.InsertText = function (txt) {
		if (editorVisible)
			insertHtml(txt);
		else
			AddTag('', txt);
	}

	this.doCmd = function (command, arg) {
		if (editorVisible) {
			ifm.focus();
			document.execCommand(command, false, arg);
			ifm.focus();
		}
		else {
			switch (command) {
				case 'bold':
					AddTag('<b>', '</b>'); break;
				case 'justifyCenter':
					AddTag("<div style='text-align:center'>", '</div>'); break;
				case 'justifyLeft':
					RemoveTag("<div style='text-align:center'>", '</div>'); break;
				case 'italic':
					AddTag('<i>', '</i>'); break;
				case 'underline':
					AddTag('<u>', '</u>'); break;
				case 'InsertUnorderedList':
					AddTag('<ul><li>', '</li></ul>'); break;
				case 'InsertOrderedList':
					AddTag('<ol><li>', '</li></ol>'); break;
			}
		}
	}

	this.doCode = function () {
		if (editorVisible) {
			ifm.focus();
			var selection = window.getSelection().getRangeAt(0);
			var selectedText = selection.extractContents();
			var span = document.createElement("code");
			span.appendChild(selectedText);
			selection.insertNode(span);
		}
		else {
			AddTag('<code>', '</code>');
		}
	}

	function doColor(color) {
		if (editorVisible) {
			ifm.focus();
			color = rgbToHex(color);
			document.execCommand('forecolor', false, color);
			ifm.focus();
		}
		else
			AddTag('<span style="color:' + color + '">', '</span>');
	}

	this.doLink = function () {
		ifm.focus();
		if (editorVisible) {
			var defaultUrl = "http://";
			var url = prompt("Enter a URL:", defaultUrl);
			if (url == null) return;
			url = url.trim();

			var sel = window.getSelection();
			if (sel && isOrContains(sel.anchorNode, ifm)) {
				var userSelection = window.getSelection().getRangeAt(0);
				//is current slection a link?
				if (userSelection.startContainer.parentNode.tagName === 'A') {
					var elem = userSelection.startContainer.parentNode;
					defaultUrl = elem.href || "http://";
					var userSelection = document.createRange();
					userSelection.setStart(elem, 0);
					userSelection.setEnd(elem, 1);
					sel.removeAllRanges();
					sel.addRange(userSelection);
				}

				if (userSelection && userSelection.toString().length == 0)
					insertHtml("<a href='" + url + "'>" + url + "</a>");
				else
					document.execCommand("CreateLink", false, url);
			}
			else
				document.execCommand("CreateLink", false, url);
		}
		else {
			var url = prompt("Enter a URL:", "http://");
			if (url == null) return;
			url = url.trim();
			AddTag('<a href="' + url + '">', '</a>');
		}
	}
	this.doImage = function () {
		var strHtml = '<table class="outerroundedbox"> \
		<tr><td class="grey"><input  type="radio" id="fromWeb" name="upload" value="0" checked="checked" onclick="document.getElementById(\'lblFileUpload\').style.visibility=\'hidden\';document.getElementById(\'txUrl\').style.visibility=\'visible\';" /> <label for="fromWeb">From the Web</label></td> \
			<td><input type="text" id="txUrl" name="txUrl" placeholder="http://"/> \
		</td></tr> \
		<tr><td class="grey"><input type="radio" id="uploadFromPC" name="upload" value="1" onclick="document.getElementById(\'txUrl\').style.visibility=\'hidden\';document.getElementById(\'lblFileUpload\').style.visibility=\'visible\';" /> <label for="uploadFromPC">From my computer</label></td> \
			<td><input type="file" id="imgfileUpload" name="fileUpload" onchange="document.getElementById(\'lblFileUpload\').innerText=this.files[0].name;" id="fileUpload" class="fancyfile"/><label for="imgfileUpload" id="lblFileUpload" style="visibility:hidden;">Select a file...</label></td></tr>\
		<tr><td colspan="2" align="right" style="padding-bottom:0"><input style="margin-bottom: 20px" type="submit" id="btnAddPic" value="Add picture"/></td></tr></table> \
		<script src="' + curScriptUrl.replace("editor.js", "fancyfile.js") + '"></script>';

		$(strHtml).modal();

		$("#btnAddPic").click(function () {
			if ($('#fromWeb').is(':checked')) { //from web
				AddImageByUrl($('#txUrl').val());
				$.modal.close();
				return false; //to prevent form submit
			}
			else //upload from computer
			{
				var file = document.getElementById("imgfileUpload").files[0];
				var reader = new FileReader();
				reader.addEventListener("load", function () {
					AddImageByUrl(reader.result);
				}, false);

				if (file) {
					reader.readAsDataURL(file);
				}

				$.modal.close();
			}
		});
		return;
	}

	this.AddImg = function (url) {
		AddImageByUrl(url);
	}

	function AddImageByUrl(url) {
		if (editorVisible) {
			ifm.focus();
			restoreCaretAfterFocus();
			if ((url != null) && (url != "")) {
				document.execCommand('InsertImage', false, url);
				$(ifm).find("img").resizable();
			}
		}
		else {
			AddTag('<img src="' + url + '">', '');
		}
	}

	function restoreCaretAfterFocus() {
		//restore range to restore cursor pos, because "click" steals focus
		if (_range && window.getSelection) {
			sel = window.getSelection();
			sel.removeAllRanges();
			sel.addRange(_range);
		}
	}

	function insertHtml(html) {
		ifm.focus();
		restoreCaretAfterFocus();

		var el = document.createElement("div");
		el.innerHTML = html;

		var sel = window.getSelection();
		if (sel.getRangeAt && sel.rangeCount && isOrContains(sel.anchorNode, ifm)) { //if selection is inside our editor?
			document.execCommand("insertHTML", false, html);
		}
		else {
			ifm.appendChild(el);
		}
		ifm.focus(); //focus back on editor, otherwise doCheck won't work cause it's triggered on blur
		autoResize();
	}

	function autoResize() {
		if (AutoResizeEditableIframe) setTimeout(function () { AutoResizeEditableIframe(ifm); }, 300);
	}	

	function isOrContains(node, container) {
		while (node) {
			if (node === container) {
				return true;
			}
			node = node.parentNode;
		}
		return false;
	}

	//textarea-mode functions
	function MozillaInsertText(element, text, pos) {
		element.value = element.value.slice(0, pos) + text + element.value.slice(pos);
	}

	function AddTag(t1, t2) {
		var element = textboxelement;
		var sel_start = element.selectionStart;
		var sel_end = element.selectionEnd;
		MozillaInsertText(element, t1, sel_start);
		MozillaInsertText(element, t2, sel_end + t1.length);
		element.selectionStart = sel_start;
		element.selectionEnd = sel_end + t1.length + t2.length;
		element.focus();
	}

	function RemoveTag(t1, t2) {
		var element = textboxelement;
		var sel_start = element.selectionStart;
		var sel_end = element.selectionEnd;
		element.value = ReplaceAt(element.value, t1, "", sel_start, sel_end);
		element.value = ReplaceAt(element.value, t2, "", sel_start, sel_end);
		element.focus();
	}

	function ReplaceAt(input, search, replace, start, end) {
		return input.slice(0, start)
			+ input.slice(start, end).replace(search, replace)
			+ input.slice(end);
	}

	function InitColorPicker($element, callback) {
		var html = '<table style="display:none;position:absolute" class="colorpick"> \
<tr><td style="background:#000"></td><td style="background:#444"></td><td style="background:#666"></td><td style="background:#999"></td><td style="background:#ccc"></td><td style="background:#eee"></td><td style="background:#f3f3f3"></td><td style="background:#fff"></td></tr> \
<tr><td style="background:#f00"></td><td style="background:#f90"></td><td style="background:#ff0"></td><td style="background:#0f0"></td><td style="background:#0ff"></td><td style="background:#00f"></td><td style="background:#90f"></td><td style="background:#f0f"></td></tr> \
<tr><td style="background:#f4cccc"></td><td style="background:#fce5cd"></td><td style="background:#fff2cc"></td><td style="background:#d9ead3"></td><td style="background:#d0e0e3"></td><td style="background:#cfe2f3"></td><td style="background:#d9d2e9"></td><td style="background:#ead1dc"></td></tr> \
<tr><td style="background:#ea9999"></td><td style="background:#f9cb9c"></td><td style="background:#ffe599"></td><td style="background:#b6d7a8"></td><td style="background:#a2c4c9"></td><td style="background:#9fc5e8"></td><td style="background:#b4a7d6"></td><td style="background:#d5a6bd"></td></tr> \
<tr><td style="background:#e06666"></td><td style="background:#f6b26b"></td><td style="background:#ffd966"></td><td style="background:#93c47d"></td><td style="background:#76a5af"></td><td style="background:#6fa8dc"></td><td style="background:#8e7cc3"></td><td style="background:#c27ba0"></td></tr> \
<tr><td style="background:#c00"></td><td style="background:#e69138"></td><td style="background:#f1c232"></td><td style="background:#6aa84f"></td><td style="background:#45818e"></td><td style="background:#3d85c6"></td><td style="background:#674ea7"></td><td style="background:#a64d79"></td></tr> \
<tr><td style="background:#900"></td><td style="background:#b45f06"></td><td style="background:#bf9000"></td><td style="background:#38761d"></td><td style="background:#134f5c"></td><td style="background:#0b5394"></td><td style="background:#351c75"></td><td style="background:#741b47"></td></tr> \
<tr><td style="background:#600"></td><td style="background:#783f04"></td><td style="background:#7f6000"></td><td style="background:#274e13"></td><td style="background:#0c343d"></td><td style="background:#073763"></td><td style="background:#20124d"></td><td style="background:#4c1130"></td></tr> \
</table>';
		var $tblPicker = $(html);
		$element.after($tblPicker);
		$tblPicker.find("td").mousedown(function (e) {
			$tblPicker.hide();
			callback($(this)[0].style.backgroundColor);
		});

		$element.click(function () {
			if (!$tblPicker[0].style.left)
				$tblPicker[0].style.left = $element.offset().left + "px";

			if (!$tblPicker.is(":visible")) {
				setTimeout(function () {
					$(window).bind('click.colorpicker', function () {
						$tblPicker.hide();
						$(window).unbind("click.colorpicker");
					});
				}, 500); //timeout added b/c it will run along with this parent click-handler
			}

			$tblPicker.toggle();
		});
	}

	function rgbToHex(color) {
		if (!color || color.indexOf("rgb") < 0 || color.charAt(0) == "#") {
			return color;
		}
		var nums = /(.*?)rgb\((\d+),\s*(\d+),\s*(\d+)\)/i.exec(color),
			r = parseInt(nums[2], 10).toString(16),
			g = parseInt(nums[3], 10).toString(16),
			b = parseInt(nums[4], 10).toString(16);
		return "#" + (
			(r.length == 1 ? "0" + r : r) +
			(g.length == 1 ? "0" + g : g) +
			(b.length == 1 ? "0" + b : b)
		);
	}

}

/**
* Bootstrap.js by @fat & @mdo
* plugins: bootstrap-dropdown.js
* Copyright 2012 Twitter, Inc.
* http://www.apache.org/licenses/LICENSE-2.0.txt
*/
!function(a){function d(){a(".dropdown-backdrop").remove(),a(b).each(function(){e(a(this)).removeClass("open")})}function e(b){var c=b.attr("data-target"),d;c||(c=b.attr("href"),c=c&&/#/.test(c)&&c.replace(/.*(?=#[^\s]*$)/,"")),d=c&&a(c);if(!d||!d.length)d=b.parent();return d}var b="[data-toggle=dropdown]",c=function(b){var c=a(b).on("click.dropdown.data-api",this.toggle);a("html").on("click.dropdown.data-api",function(){c.parent().removeClass("open")})};c.prototype={constructor:c,toggle:function(b){var c=a(this),f,g;if(c.is(".disabled, :disabled"))return;return f=e(c),g=f.hasClass("open"),d(),g||("ontouchstart"in document.documentElement&&a('<div class="dropdown-backdrop"/>').insertBefore(a(this)).on("click",d),f.toggleClass("open")),g||f.trigger("dropdown:show"),!1}};var f=a.fn.dropdown;a.fn.dropdown=function(b){return this.each(function(){var d=a(this),e=d.data("dropdown");e||d.data("dropdown",e=new c(this)),typeof b=="string"&&e[b].call(d)})},a.fn.dropdown.Constructor=c,a.fn.dropdown.noConflict=function(){return a.fn.dropdown=f,this},a(document).on("click.dropdown.data-api",d).on("click.dropdown.data-api",".dropdown form",function(a){a.stopPropagation()}).on("click.dropdown.data-api",b,c.prototype.toggle)}(window.jQuery)
;
/*
jquery-resizable
Version 0.35 - 11/18/2019
© 2015-2019 Rick Strahl, West Wind Technologies
www.west-wind.com
Licensed under MIT License
HEAVILY MODIFIED BY JITBIT
*/
(function ($) {

	if ($.fn.resizableSafe)
		return;

	$.fn.resizableSafe = function fnResizable() {
		return this.each(function () {
			var opt = { instanceId: "rsz_" + new Date().getTime() };

			var startPos, startTransition;

			// get the element to resize 
			var $el = $(this);
			$el.data('resizable', opt);
			$el.addClass("resizable");
			$el.css('max-width', '100%');

			$el.on("mousedown." + opt.instanceId, startDragging);

			function noop(e) {
				e.stopPropagation();
				e.preventDefault();
			};

			function startDragging(e) {
				e.preventDefault();

				startPos = getMousePos(e);
				startPos.width = parseInt($el.width(), 10);
				startPos.height = parseInt($el.height(), 10);

				startTransition = $el.css("transition");
				$el.css("transition", "none");

				$(document).on('mousemove.' + opt.instanceId, doDrag);
				$(document).on('mouseup.' + opt.instanceId, stopDragging);
				$(document).on('selectstart.' + opt.instanceId, noop); // disable selection
				$("iframe").css("pointer-events", "none");
			}

			function doDrag(e) {
				var pos = getMousePos(e);
				var newWidth = startPos.width - startPos.x + pos.x;
				$el.width(newWidth);
			}

			function stopDragging(e) {
				e.stopPropagation();
				e.preventDefault();

				$(document).off('mousemove.' + opt.instanceId);
				$(document).off('mouseup.' + opt.instanceId);
				$(document).off('selectstart.' + opt.instanceId, noop);

				// reset changed values
				$el.css("transition", startTransition);
				$("iframe").css("pointer-events", "auto");

				return false;
			}

			function getMousePos(e) {
				return { x: e.clientX, y: e.clientY };
			}
		});
	};

	if (!$.fn.resizable)
		$.fn.resizable = $.fn.resizableSafe;
})(jQuery);