﻿var loadedscripts = document.getElementsByTagName("script");
var helpdeskUrl;
var categoryId;
for (i = 0; loadedscripts.length; i++) {
	if (!loadedscripts[i] && !loadedscripts[i].src) continue;

	if (loadedscripts[i].src.includes('support-widget.js')) {
		helpdeskUrl = loadedscripts[i].src;
		categoryId = loadedscripts[i].getAttribute("data-categoryid");
		break;
	}
}
helpdeskUrl = helpdeskUrl.split('/').slice(0, -1).join('/');
helpdeskUrl = helpdeskUrl.split('/').slice(0, -1).join('/') + '/';

//wait for DOM to load completely
(function () {
	var tId = setInterval(function () { if (document.readyState == "complete") onDocComplete() }, 300);
	function onDocComplete() {
		clearInterval(tId);
		LoadSupportWidget();
	};
})()

function LoadSupportWidget() {
	if (helpdeskUrl.substr(helpdeskUrl.length - 1) != "/") //normalizing the URL
		helpdeskUrl += "/";

	//add css style
	AddFancyBoxCSS();

	//load jquery
	if (!window.jQuery) GetScript("https://ajax.googleapis.com/ajax/libs/jquery/2.2.4/jquery.min.js");
	TryJQueryReady(0);
}

function CreateSupportWidget(widgetalign) {
	var xPos = (widgetalign == "right") ? "right:0px" : "left:0px";

	//add widget
	document.write("<a class='SupportWidget' style='display:block;position:fixed;top:50%;margin-top:-64px;" + xPos + "'>");
	document.write("<img src='https://cdn.jitbit.com/helpdesk/images/support_tab.png' style='border:none;' />");
	document.write("</a>");

	TryJQueryReady(0);
}

//this function is for backward compatibility only
function SupportWidget(hdUrl, widgetalign) {
	if (widgetalign)
		CreateSupportWidget(widgetalign);
}

function SupportWidgetStep2() {
	jQuery(document).ready(function () {
		jQuery('.SupportWidget').attr('href', helpdeskUrl + 'Tickets/New/?SimpleMaster=1&ReferrerUrl=' + encodeURIComponent(window.location.href) + (categoryId ? '&categoryId=' + categoryId : ""));

		if (!window.fancyboxLoading) { //to prevent adding fancybox 2 times
			window.fancyboxLoading = true;
			GetScript("https://cdn.jitbit.com/helpdesk/js/jquery.fancybox.es5.min.js");
		}
		TryFancyboxReady(0);
	});
}

function SupportWidgetStep3() {
	//not for iphones and ipads
	if (navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPod/i) || navigator.userAgent.match(/iPad/i)) return;

	jQuery('.SupportWidget').fancybox({
		'width': 800,
		'height': 600,
		'autoScale': false,
		'transitionIn': 'fade',
		'transitionOut': 'none',
		'type': 'iframe',
		padding: 0
	});
	//jQuery.fancybox.init(); //reinit - safari fix
}

function AddFancyBoxCSS() {
	var headtg = document.getElementsByTagName('head')[0];
	if (!headtg) {
		return;
	}
	var linktg = document.createElement('link');
	linktg.type = 'text/css';
	linktg.rel = 'stylesheet';
	linktg.href = 'https://cdn.jitbit.com/helpdesk/js/jquery.fancybox.css';
	headtg.appendChild(linktg);
}

// dynamically load any javascript file.
function GetScript(filename) {
	var script = document.createElement('script')
	script.setAttribute("type", "text/javascript")
	script.setAttribute("src", filename)
	if (typeof script != "undefined")
		document.getElementsByTagName("head")[0].appendChild(script)
}

function TryJQueryReady(time_elapsed) {
	// Continually polls to see if jQuery is loaded.
	if (typeof jQuery == "undefined") { // if jQuery isn't loaded yet...
		if (time_elapsed <= 10000) { // and we havn't given up trying...
			setTimeout("TryJQueryReady(" + (time_elapsed + 200) + ")", 200); // set a timer to check again in 200 ms.
		} else {
			return;
		}
	} else {
		SupportWidgetStep2();
	}
}

function TryFancyboxReady(time_elapsed) {
	// Continually polls to see if fancybox is loaded.
	if (typeof jQuery.fancybox == "undefined") { // if fancybox isn't loaded yet...
		if (time_elapsed <= 10000) { // and we havn't given up trying...
			setTimeout("TryFancyboxReady(" + (time_elapsed + 200) + ")", 200); // set a timer to check again in 200 ms.
		} else {
			return
		}
	} else {
		SupportWidgetStep3();
	}
}